diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChat.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChat.java
index 665fac4a2..db08a3f14 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChat.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChat.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui.hud.component;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.options.components.BooleanToggleComponent;
 import net.minecraft.client.gui.options.components.FloatSliderComponent;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.enums.ChatVisibility;
@@ -15,8 +16,10 @@ import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 
+import java.util.ArrayDeque;
 import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.Deque;
 import java.util.List;
 
 public class HudComponentChat extends HudComponentMovable {
@@ -28,11 +31,22 @@ public class HudComponentChat extends HudComponentMovable {
     public static final int MAX_RESIZE_HEIGHT = 1000;
     private static final int CHAT_PADDING = 2;
     private static final int LINE_SPACING = 2;
+    private static final int LINE_HEIGHT = 9;
+    private static final int LINE_STEP = LINE_HEIGHT + LINE_SPACING;
     public final @NotNull List<@NotNull ChatLine> chatMessageList = new ArrayList<>();
     public int chatScroll = 0;
 
+    /** Newest first, one entry per visual line */
+    private final @NotNull List<@NotNull VisualLine> visualLines = new ArrayList<>();
+    private boolean visualLinesDirty = true;
+    private int visualLinesWrapWidth = -1;
+    private Object visualLinesFont = null;
+
+    private static final boolean DEFAULT_FULL_WIDTH_BACKDROP = false;
+
     private int customWidth;
     private int customHeight;
+    private boolean fullWidthBackdrop = DEFAULT_FULL_WIDTH_BACKDROP;
 
     public HudComponentChat(String key, int xSize, int ySize, Layout layout) {
         super(key, xSize, ySize, layout);
@@ -60,6 +74,13 @@ public class HudComponentChat extends HudComponentMovable {
             value -> this.customHeight = Math.round(value),
             value -> Math.round(value) + "px"
         ));
+
+        addOptionComponentSupplier(() -> new BooleanToggleComponent(
+            "gui.options.hudeditor.chat_full_width_backdrop",
+            DEFAULT_FULL_WIDTH_BACKDROP,
+            () -> this.fullWidthBackdrop,
+            value -> this.fullWidthBackdrop = value
+        ));
     }
 
     @Override
@@ -74,7 +95,7 @@ public class HudComponentChat extends HudComponentMovable {
 
     @Override
     protected String toSettingsParametersString() {
-        return "w=" + this.customWidth + ",h=" + this.customHeight;
+        return "w=" + this.customWidth + ",h=" + this.customHeight + ",backdrop=" + (this.fullWidthBackdrop ? 1 : 0);
     }
 
     @Override
@@ -91,6 +112,8 @@ public class HudComponentChat extends HudComponentMovable {
                     this.customWidth = MathHelper.clamp(parsed, MIN_CHAT_WIDTH, MAX_RESIZE_WIDTH);
                 } else if (key.equals("h")) {
                     this.customHeight = MathHelper.clamp(parsed, MIN_CHAT_HEIGHT, MAX_RESIZE_HEIGHT);
+                } else if (key.equals("backdrop")) {
+                    this.fullWidthBackdrop = parsed != 0;
                 }
             } catch (NumberFormatException ignored) {}
         }
@@ -156,6 +179,7 @@ public class HudComponentChat extends HudComponentMovable {
 
     public void clearChatMessages() {
         this.chatMessageList.clear();
+        this.visualLinesDirty = true;
     }
 
     public void addChatMessage(final CharSequence s) {
@@ -163,121 +187,195 @@ public class HudComponentChat extends HudComponentMovable {
         while (this.chatMessageList.size() > 100) {
             this.chatMessageList.remove(this.chatMessageList.size() - 1);
         }
+        this.visualLinesDirty = true;
     }
 
     private int getMessageWrapWidth() {
         return Math.max(1, this.customWidth - (CHAT_PADDING * 2));
     }
 
+    /**
+     * A single wrapped line of a chat message. Multi line messages produce several of these,
+     * all sharing the {@link ChatLine} they came from so they fade out together.
+     */
+    private static class VisualLine {
+        final @NotNull ChatLine source;
+        final @NotNull String text;
+
+        VisualLine(@NotNull ChatLine source, @NotNull String text) {
+            this.source = source;
+            this.text = text;
+        }
+    }
+
+    /**
+     * Returns every chat message split into wrapped lines, newest line first. The result is cached
+     * until the message list, the wrap width or the font changes.
+     */
+    private @NotNull List<@NotNull VisualLine> getVisualLines(int wrapWidth) {
+        Object font = mc.font.getFont();
+        if (!this.visualLinesDirty && this.visualLinesWrapWidth == wrapWidth && this.visualLinesFont == font) {
+            return this.visualLines;
+        }
+
+        this.visualLines.clear();
+        List<String> split = new ArrayList<>();
+        for (ChatLine line : this.chatMessageList) {
+
+            mc.font.splitCharsIntoLines(line.message, wrapWidth, split);
+            carryFormattingBetweenLines(split);
+
+            for (int i = split.size() - 1; i >= 0; i--) {
+                this.visualLines.add(new VisualLine(line, split.get(i)));
+            }
+
+        }
+
+        this.visualLinesDirty = false;
+        this.visualLinesWrapWidth = wrapWidth;
+        this.visualLinesFont = font;
+        return this.visualLines;
+    }
+
+    /**
+     * Re-apply codes that were still active at the end of the previous line to the start of the next one.
+     */
+    private static void carryFormattingBetweenLines(@NotNull List<String> lines) {
+        StringBuilder active = new StringBuilder();
+        Deque<String> pushed = new ArrayDeque<>();
+        for (int i = 0; i < lines.size(); i++) {
+            String line = lines.get(i);
+            if (i > 0 && !active.isEmpty()) {
+                lines.set(i, active + line);
+            }
+            for (int j = 0; j < line.length() - 1; j++) {
+                if (line.charAt(j) != '§') continue;
+                if (line.charAt(j + 1) == '<') {
+                    int end = line.indexOf('>', j + 2);
+                    if (end == -1) continue;
+                    active.setLength(0);
+                    active.append(line, j, end + 1);
+                    j = end;
+                    continue;
+                }
+
+                char code = Character.toLowerCase(line.charAt(j + 1));
+                j++;
+                if (code == '+') {
+                    pushed.push(active.toString());
+                } else if (code == '-') {
+                    active.setLength(0);
+                    if (!pushed.isEmpty()) active.append(pushed.pop());
+                } else if (code == 'r') {
+                    active.setLength(0);
+                } else {
+                    // A color code clears every style before it, so drop what we have.
+                    if ((code >= '0' && code <= '9') || (code >= 'a' && code <= 'f')) {
+                        active.setLength(0);
+                    }
+                    active.append('§').append(code);
+                }
+            }
+        }
+    }
+
     private void drawChat(HudIngame hud, int xSizeScreen, int ySizeScreen) {
         int x = this.getLayout().getComponentX(this, xSizeScreen);
         int y = this.getLayout().getComponentY(this, ySizeScreen);
 
         int wrapWidth = getMessageWrapWidth();
-        int singleLineHeight = 9 + LINE_SPACING;
-        int linesToShow = Math.max(1, (this.customHeight - CHAT_PADDING * 2) / singleLineHeight);
+        int linesToShow = Math.max(1, (this.customHeight - CHAT_PADDING * 2) / LINE_STEP);
         boolean ignoreFadeout = false;
         if (mc.currentScreen instanceof ScreenChat) {
             int acceptableSize = ySizeScreen - 48 - 48;
-            linesToShow = Math.max(linesToShow, acceptableSize / singleLineHeight);
+            linesToShow = Math.max(linesToShow, acceptableSize / LINE_STEP);
             ignoreFadeout = true;
         }
 
-        if (this.chatScroll > this.chatMessageList.size() - linesToShow)
-            this.chatScroll = this.chatMessageList.size() - linesToShow;
-        if (this.chatScroll < 0) this.chatScroll = 0;
+        List<VisualLine> lines = getVisualLines(wrapWidth);
+
+        this.chatScroll = MathHelper.clamp(this.chatScroll, 0, Math.max(0, lines.size() - linesToShow));
 
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
-        int linesUsed = Math.min(linesToShow, this.chatMessageList.size() - this.chatScroll);
-        int totalHeight = computeTotalHeight(this.chatMessageList, this.chatScroll, linesUsed, ignoreFadeout, wrapWidth);
+        int linesUsed = Math.min(linesToShow, lines.size() - this.chatScroll);
+        int totalHeight = 0;
+        for (int i = 0; i < linesUsed; i++) {
+            if (getLineAlpha(lines.get(this.chatScroll + i).source, ignoreFadeout) > 0) totalHeight += LINE_STEP;
+        }
 
         float yMult = GameSettings.VERTICAL_CHAT_TEXT_ALIGNMENT.value.multiplier;
         int alignmentSpace = this.getBaseYSize() - (CHAT_PADDING * 2) - totalHeight;
 
         int currentY = y + this.getBaseYSize() - CHAT_PADDING - (int) (alignmentSpace * (1 - yMult));
-        for (int i = 0; i < linesToShow; i++) {
-            if (this.chatScroll + i >= this.chatMessageList.size()) continue;
-            final ChatLine line = this.chatMessageList.get(this.chatScroll + i);
-            if (line.updateCounter >= 190 && !ignoreFadeout) {
-                continue;
-            }
-            double fadeAmount = (double) line.updateCounter / 200D;
-            fadeAmount = 1.0D - fadeAmount;
-            fadeAmount *= 10D;
-            if (fadeAmount < 0.0D) {
-                fadeAmount = 0.0D;
-            }
-            if (fadeAmount > 1.0D) {
-                fadeAmount = 1.0D;
-            }
-            fadeAmount *= fadeAmount;
-            int alpha = (int) (255D * fadeAmount);
-            if (ignoreFadeout) {
-                alpha = 255;
-            }
+        for (int i = 0; i < linesUsed; i++) {
+            final VisualLine line = lines.get(this.chatScroll + i);
+            int alpha = getLineAlpha(line.source, ignoreFadeout);
             if (alpha > 0) {
-                final CharSequence message = line.message;
-                final int h = MathHelper.ceil(mc.font.heightOfConstrainedChars(message, wrapWidth));
-                currentY -= (h + LINE_SPACING);
-                drawAlignedLine(hud, mc.font, message, x, currentY, h, alpha, wrapWidth);
+                currentY -= LINE_STEP;
+                drawAlignedLine(hud, mc.font, line.text, x, currentY, alpha, wrapWidth);
             }
         }
         GLRenderer.disableState(State.BLEND);
     }
 
+    private static int getLineAlpha(@NotNull ChatLine line, boolean ignoreFadeout) {
+        if (ignoreFadeout) return 255;
+        if (line.updateCounter >= 190) return 0;
+        double fadeAmount = 1.0D - (double) line.updateCounter / 200D;
+        fadeAmount *= 10D;
+        if (fadeAmount < 0.0D) {
+            fadeAmount = 0.0D;
+        }
+        if (fadeAmount > 1.0D) {
+            fadeAmount = 1.0D;
+        }
+        fadeAmount *= fadeAmount;
+        return (int) (255D * fadeAmount);
+    }
+
     private void drawLines(Gui gui, FontRenderer sr, @NotNull List<String> messages, int x, int y, int alpha) {
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
 
         int wrapWidth = getMessageWrapWidth();
-        int maxContentHeight = Math.max(1, this.getBaseYSize() - (CHAT_PADDING * 2));
-        List<String> visibleMessages = new ArrayList<>();
-        int totalHeight = 0;
+        int maxLines = Math.max(1, (this.getBaseYSize() - (CHAT_PADDING * 2)) / LINE_STEP);
+
+        List<String> visibleLines = new ArrayList<>();
+        List<String> split = new ArrayList<>();
         for (String message : messages) {
-            int lineHeight = MathHelper.ceil(sr.heightOfConstrainedChars(message, wrapWidth)) + LINE_SPACING;
-            if (totalHeight + lineHeight > maxContentHeight) {
-                break;
+            if (visibleLines.size() >= maxLines) break;
+            sr.splitCharsIntoLines(message, wrapWidth, split);
+            carryFormattingBetweenLines(split);
+            for (int i = split.size() - 1; i >= 0 && visibleLines.size() < maxLines; i--) {
+                visibleLines.add(split.get(i));
             }
-            visibleMessages.add(message);
-            totalHeight += lineHeight;
         }
 
         float yMult = GameSettings.VERTICAL_CHAT_TEXT_ALIGNMENT.value.multiplier;
+        int totalHeight = visibleLines.size() * LINE_STEP;
         int alignmentSpace = this.getBaseYSize() - (CHAT_PADDING * 2) - totalHeight;
 
         int currentY = y + this.getBaseYSize() - CHAT_PADDING - (int) (alignmentSpace * (1 - yMult));
-        for (String message : visibleMessages) {
-            final int h = MathHelper.ceil(sr.heightOfConstrainedChars(message, wrapWidth));
-            currentY -= (h + LINE_SPACING);
-            drawAlignedLine(gui, sr, message, x, currentY, h, alpha, wrapWidth);
+        for (String line : visibleLines) {
+            currentY -= LINE_STEP;
+            drawAlignedLine(gui, sr, line, x, currentY, alpha, wrapWidth);
         }
 
         GLRenderer.disableState(State.BLEND);
     }
 
-    private void drawAlignedLine(@NotNull Gui gui, @NotNull FontRenderer sr, CharSequence message, int x, int currentY, int h, int alpha, int wrapWidth) {
+    /** Draws one already wrapped line, honoring the horizontal alignment option. */
+    private void drawAlignedLine(@NotNull Gui gui, @NotNull FontRenderer sr, CharSequence line, int x, int currentY, int alpha, int wrapWidth) {
         float xMult = GameSettings.HORIZONTAL_CHAT_TEXT_ALIGNMENT.value.multiplier;
-        int textWidth = Math.min(wrapWidth, (int) sr.stringWidthDouble(message));
+        int textWidth = Math.min(wrapWidth, MathHelper.ceil(sr.stringWidthDouble(line)));
         int boxWidth = this.getBaseXSize() - (CHAT_PADDING * 2);
         int renderX = x + CHAT_PADDING + (int) ((boxWidth - textWidth) * xMult);
-        int boxLeft = renderX - 1;
-        int boxRight = renderX + textWidth + 1;
-        gui.drawRect(boxLeft, currentY - 1, boxRight, currentY + h + 1, alpha / 2 << 24);
+        int backdropLeft = this.fullWidthBackdrop ? x : renderX - 1;
+        int backdropRight = this.fullWidthBackdrop ? x + this.getBaseXSize() : renderX + textWidth + 1;
+        gui.drawRect(backdropLeft, currentY - 1, backdropRight, currentY + LINE_HEIGHT + 1, alpha / 2 << 24);
         GLRenderer.enableState(State.BLEND);
-        sr.renderWidthConstrained(message, renderX, currentY, wrapWidth).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
-    }
-
-    private int computeTotalHeight(List<ChatLine> messages, int scroll, int linesUsed, boolean ignoreFadeout, int wrapWidth) {
-        int total = 0;
-        for (int i = 0; i < linesUsed; i++) {
-            int idx = scroll + i;
-            if (idx >= messages.size()) continue;
-            ChatLine line = messages.get(idx);
-            if (line.updateCounter >= 190 && !ignoreFadeout) continue;
-            total += MathHelper.ceil(mc.font.heightOfConstrainedChars(line.message, wrapWidth)) + LINE_SPACING;
-        }
-        return total;
+        sr.render(line, renderX, currentY).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChatInput.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChatInput.java
index d3f78bb73..b01eba9cd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChatInput.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentChatInput.java
@@ -11,7 +11,12 @@ import net.minecraft.client.render.renderer.State;
 import org.jetbrains.annotations.NotNull;
 
 public class HudComponentChatInput extends HudComponentMovable {
+    public static final int LINE_HEIGHT = 10;
+    public static final int FIELD_X_OFFSET = 14;
+    private static final int FIELD_PADDING = 2;
+
     private HudComponentChat linkedChat;
+    private int lineCount = 1;
 
     public HudComponentChatInput(String key, int xSize, int ySize, Layout layout) {
         super(key, xSize, ySize, layout);
@@ -21,11 +26,32 @@ public class HudComponentChatInput extends HudComponentMovable {
         this.linkedChat = chat;
     }
 
+    public void setLineCount(int lineCount) {
+        this.lineCount = Math.max(1, lineCount);
+    }
+
+    public int getLineCount() {
+        return this.lineCount;
+    }
+
+    public int getTextWrapWidth() {
+        return Math.max(1, getBaseXSize() - FIELD_X_OFFSET - FIELD_PADDING * 2);
+    }
+
+    public int getBoxHeight() {
+        return FIELD_PADDING + this.lineCount * LINE_HEIGHT;
+    }
+
     @Override
     public int getBaseXSize() {
         return this.linkedChat != null ? this.linkedChat.getBaseXSize() : super.getBaseXSize();
     }
 
+    @Override
+    public int getBaseYSize() {
+        return super.getBaseYSize() + (this.lineCount - 1) * LINE_HEIGHT;
+    }
+
     @Override
     public OptionGuiScaleOverride getGuiScaleOverrideOption() {
         return this.linkedChat != null ? this.linkedChat.getGuiScaleOverrideOption() : super.getGuiScaleOverrideOption();
diff --git a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
index 9e56daab6..8e5b5df1c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/PostProcessingManager.java
@@ -95,13 +95,13 @@ public class PostProcessingManager {
         this.lastHumidity = humidity;
 
         // Perform base temperature change
-        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.OVERWORLD)) {
+        if (ccValue != 0 && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.OVERWORLD)) {
             this.lastTemperature = temperature;
             final double tt = (temperature * 2) - 1.0; // Ranges from -1.0 to 1.0
             this.current.saturation += (float) (0.25 * tt * surfaceness);
             this.current.contrast += (float) (-0.1 * tt * surfaceness);
         }
-        if (this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.HOT)) {
+        if (ccValue != 0 && this.mc.currentWorld.getWorldType().hasTag(WorldTypeTags.HOT)) {
             this.lastTemperature = temperature;
             if (temperature < 0.5) {
                 final double tt = temperature * 2; // Ranges from 0.0 to 1.0
